#!/usr/bin/php -q
<?php
// Copyright (C) 2008 - 2011 vortexbox.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// some code from LinuxMCE
//

require_once("/opt/vortexbox/amazonTools.inc.php");

define('SUBID', '17Z9F60P7FBV64QEF9G2');   	
define('SECRETKEY','4CZZr12TwQ1nSMD3IpyeKae2/RsPr+3K44cMRutg');              
define('AES_VERSION','2009-03-31');        	// The version of AES

$timeStamp = gmdate("Y-m-d\TH:i:s\Z");

$folders = glob('*');

$ctx = stream_context_create(array(
    'http' => array(
        'timeout' => 10
        )
    )
);
 
if(empty($argv[1])) {
	echo "CoverGrabber    Copyright (C) vortexbox.org\n";
	echo "You need to give a folder name as a command line arg.\n";
	exit;
} else {
	$folder = $argv[1];
}	
	
if(!is_dir($folder)) {
	echo "Skipping {$folder}. Not a folder?\n";
	exit;
}

if(is_file($folder."/cover.jpg")) {
	echo "Already have cover art for {$folder}.\n";
	exit;
}

// read metatags on first FLAC file in folder	
$firstflac = glob($folder."/*.flac");
if(empty($firstflac[0])) { echo "Skipping {$folder} no FLACs.\n"; exit;}

$artist = urlencode(exec("metaflac --show-tag=artist \"" . $firstflac[0]. "\" | sed 's/.*=//g'"));
$album = urlencode(exec("metaflac --show-tag=album \"". $firstflac[0]. "\" | sed 's/.*=//g'"));
if($album == "Unknown+Album") { echo "Unknown Album - No cover art to get.\n"; exit;}

echo "\nGetting cover art for {$folder} ...\n";

//------------------------------------------------------------------------------
// Make the request for cover arts using album and artist
//------------------------------------------------------------------------------

$request='Version='.AES_VERSION.'&Operation=ItemSearch&SearchIndex=Music&ResponseGroup=Medium&Sort=relevancerank&Artist='.$artist.'&Title='.$album;
//echo $request;

// START CHANGES FOR SIGNED REQUEST
// see http://docs.amazonwebservices.com/AWSECommerceService/latest/DG/index.ht... for more details

//Substitute your real Access Id here...
$request = 'Service=AWSECommerceService&AssociateTag=vort-20&'.'AWSAccessKeyId='.SUBID.'&Timestamp='.$timeStamp.'&'.$request;

// encode url - replace commas w/ %2C, replace colon w/ %3A
// Could use urlencode($request) here, but $request may already be partially encoded
$request = str_replace(',','%2C', $request);
$request = str_replace(':','%3A', $request);
$request = str_replace('+','%2B', $request);

//break request string into key/value pairs,
$reqarr = explode('&',$request);

//sort on byte value
sort($reqarr);

// tie back together w/ &'s
$string_to_sign = implode("&", $reqarr);

$string_to_sign = "GET\nwebservices.amazon.com\n/onca/xml\n".$string_to_sign;

//Substitute your real Secret Key here...
$signature = urlencode(base64_encode(hash_hmac("sha256", $string_to_sign, SECRETKEY, True)));

$request .= '&Signature='.$signature;
$request = 'http://webservices.amazon.com/onca/xml?'.$request;

//echo $request;

// Get the response from Amazon
$xml = file_get_contents($request);

// Parse the results
$Result = xmlparser($xml);

// Check to see if we got results from amazon
if (isset($Result['ItemSearchResponse']['Items'][0]['Request']['Errors']['Error'][0]['Code'])) {
	if($Result['ItemSearchResponse']['Items'][0]['Request']['Errors']['Error'][0]['Code'] == "AWS.ECommerceService.NoExactMatches"){
		$no_amazon=1;
	} else {
		$no_amazon=0;
	}
}else{
	$no_amazon=0;
}


//------------------------------------------------------------------------------
// Make the request for cover arts using album as keywords
//------------------------------------------------------------------------------

if($no_amazon == 1) {
// Make the request for cover arts using album and artist
$request='Version='.AES_VERSION.'&Operation=ItemSearch&SearchIndex=Music&ResponseGroup=Medium&Sort=relevancerank&Keywords='.$album;

// START CHANGES FOR SIGNED REQUEST
// see http://docs.amazonwebservices.com/AWSECommerceService/latest/DG/index.ht... for more details

//Substitute your real Access Id here...
$request = 'Service=AWSECommerceService&AssociateTag=vort-20&'.'AWSAccessKeyId='.SUBID.'&Timestamp='.$timeStamp.'&'.$request;

// encode url - replace commas w/ %2C, replace colon w/ %3A
// Could use urlencode($request) here, but $request may already be partially encoded
$request = str_replace(',','%2C', $request);
$request = str_replace(':','%3A', $request);
$request = str_replace('+','%2B', $request);

//break request string into key/value pairs,
$reqarr = explode('&',$request);

//sort on byte value
sort($reqarr);

// tie back together w/ &'s
$string_to_sign = implode("&", $reqarr);

$string_to_sign = "GET\nwebservices.amazon.com\n/onca/xml\n".$string_to_sign;

//Substitute your real Secret Key here...
$signature = urlencode(base64_encode(hash_hmac("sha256", $string_to_sign, SECRETKEY, True)));

$request .= '&Signature='.$signature;
$request = 'http://webservices.amazon.com/onca/xml?'.$request;

//echo $request;

// Get the response from Amazon
$xml = file_get_contents($request);

// Parse the results
$Result = xmlparser($xml);

// Check to see if we got results from amazon
if (isset($Result['ItemSearchResponse']['Items'][0]['Request']['Errors']['Error'][0]['Code'])) {
	if($Result['ItemSearchResponse']['Items'][0]['Request']['Errors']['Error'][0]['Code'] == "AWS.ECommerceService.NoExactMatches"){
		$no_amazon=1;
	} else {
		$no_amazon=0;
	}
}else{
	$no_amazon=0;
}
}


if($no_amazon == 1) {

echo "No cover art found on Amazon.com, let's check Google Images.\n";

// make one last attempt to find cover art
$album = $artist . " ". $album;
echo "Checking Google Images for {$album}...\n";

$googleUrl = "http://images.google.com/images?um=1&hl=en&safe=off&imgsz=medium&q=".urlencode($album);
$contents = file_get_contents($googleUrl,0,$ctx);

if(preg_match_all('/imgurl\\\\x3d(.*?)\\\\x26/i',$contents,$matches)) {
	foreach($matches[1] as $image) {
		if($imageContents = file_get_contents($image,0,$ctx)) {
			file_put_contents("{$folder}/cover.jpg",$imageContents);
			echo "Found image {$image}\n";
			break;
		}
	}
} else {
	echo "No cover art found on Google Images, giving up!.\n";;
}

}else{

$found=0;
foreach ($Result['ItemSearchResponse']['Items'][0]['Item'] as $item) {
	$found++;
	if (isset($item['LargeImage']['URL'])) {
		// grab attributes
		$attributes="ASIN\t".$item["ASIN"][0]."\n";
		//print_r($item['ItemAttributes']);
		foreach ($item['ItemAttributes'] AS $attributeName=>$values){
			if(is_array($values)){
				foreach ($values AS $subAttributeName=>$value){
					if(!is_array($value)){
						$attributes.=(is_int($subAttributeName)?$attributeName:$subAttributeName)."\t".$value."\n";
					}else{
						// TODO: particular cases, like Creator
						// I left them for now
					}
				}
			}else{
				$attributes.=$attributeName."\t".$values."\n";
			}
		}		
		if(isset($item['EditorialReviews']['EditorialReview'][0]['Content'])){
			$attributes.="Synopsis\t".nl2br($item['EditorialReviews']['EditorialReview'][0]['Content'])."\n";
		}
		
		// grab the cover art if exist, download it and save the record in database
		if(!is_file($folder."/cover.jpg")) {
		savePic($item['LargeImage']['URL'],$folder.'/cover.jpg');
		break;
		}
	}
//$resizeFlag=resizeImage($coverArtPath.$entryID.'.jpg', $coverArtPath.$entryID.'_tn.jpg', 256, 256);

}
}

echo "Done getting cover art for {$folder}\n\n";

function savePic($url,$path){
	// remove \n from url
	$url=str_replace("\n",'',$url);
	
	// copy the pic localy if the param is specified
	// path need to be a working path with write permission
	if($path!=''){
		if(file_exists($path)){
			$cmd='sudo -u root rm -f "'.$path.'"';
			exec($cmd);
		}
		$getPicCmd='wget --header=\'User-Agent: Lynx/2.8.5rel.1 libwww-FM/2.14 SSL-MM/1.4.1 GNUTLS/1.0.16\' -O - \''.$url.'\' > "'.$path.'"';
		$coverArtPage=exec($getPicCmd);
	}
}
	
?>
