#!/usr/bin/php
<?php
// Copyright (C) 2008 - 2011 vortexbox.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// Changelog:
//
// Wed Jun 01 2011 Ron Olsen <ronolsen@comcast.net>
// * Call get-cddevice to get the device name instead of hard-coding /dev/sr0.
//
error_reporting(E_ERROR);
require_once ("/var/www/html/libs/class.xmltoarray.php");

// cleanup
exec("mkdir -p /storage/tmp/ripper.tmp/");
exec("rm -rf /storage/tmp/ripper.tmp/*");

// Get device name

$cddevice=exec("/opt/vortexbox/get-cddevice");
echo "Using device $cddevice\n";

echo "Reading DVD track info.\n";

// time how long it takes to rip movie
$start_time = getdate();
//get info from DVD
exec("/usr/bin/lsdvd -Ox $cddevice > /tmp/docd_helper.tmp");
$xml_data_dvd  = file_get_contents("/tmp/docd_helper.tmp");
$xmlObj_dvd    = new XmlToArray($xml_data_dvd);
$dvdData = $xmlObj_dvd->createArray();
$movie_title_dvd=$dvdData['lsdvd']['title'];

// see if it exists on-line
echo "Getting DVD name.\n";
$dvdid=exec("/opt/vortexbox/getdvdid.sh");
//$dvdid="";
//$movie_title_dvd="";

$movie_title_ol=exec('/usr/bin/php /opt/vortexbox/getdvdname.php "'.$dvdid.'" "'.$movie_title_dvd.'"');

if (substr($movie_title_ol,0,1) == "0") { 
	$movie_title = trim($movie_title_dvd);
} else {
	$movie_title = trim($movie_title_ol);
}

if ($movie_title == "") { $movie_title = "Unknown"; }

echo "\nRipping ".$movie_title. " to /storage/movies...\n\n";
echo "Track info\n";
echo "--------------------\n";

$length = 0;
$long_track = 0;
$long_track_lsdvd = 0;
$loop = 0;
foreach ($dvdData["lsdvd"]["track"] as $v => $value) {
	echo "Track ".($v + 1)." is ".$dvdData['lsdvd']['track'][$v]['length']." seconds long.\n";
	$loop++;
	if ($dvdData["lsdvd"]["track"][$v]["length"] > 120) {
	  if ($dvdData["lsdvd"]["track"][$v]["length"] > $length) { 
		$length = $dvdData["lsdvd"]["track"][$v]["length"];
		$long_track++;
		$long_track_lsdvd=$loop;
		$long_track_lsdvd_length=$length;
	  }
	}
}
if ($long_track == 0) { $long_track = 1;}

// check if DVD is a TV show archive and enable multi rip
if ($long_track_lsdvd_length < 3900) {
	echo "\nNo tracks longer than 60 minutes. Looks like a TV show disk.\n";
	$length = 1080;
	$multirip = 1;
}

// Check for user selected multi rip
if (file_exists("/etc/vortexbox/ripdvdlength")) { 
	$length = trim(exec("/bin/cat /etc/vortexbox/ripdvdlength")); 
	$multirip = 1;
}

// Rip the DVD!

putenv("USER=root");
putenv("HOME=/root");

// Multi rip
if ($multirip == 1) {
	echo "\nRipping tracks longer than ".$length." seconds.\n\n";
	exec("/usr/bin/makemkvcon mkv --decrypt --progress=-stdout --minlength=".$length." dev:$cddevice all /storage/tmp/ripper.tmp >> /var/log/cdrip.log");

	if (glob("/storage/tmp/ripper.tmp/*.mkv") != false){
		$filecount = count(glob("/storage/tmp/ripper.tmp/*.mkv"));
		echo "Found: $filecount files that were ripped from DVD\n";
	}
	// If disk name already exists create a new directory title
	if (file_exists("/storage/movies/$movie_title")) {
		$directory_name = "$movie_title-$start_time[0]";
		echo "Directory already exists, renaming output folder to: $directory_name\n";
	} else {
		$directory_name = $movie_title;
	}
	exec('mkdir -p "/storage/movies/'.$directory_name.'"');
	exec('for f in /storage/tmp/ripper.tmp/*.mkv; do mv "$f" "/storage/movies/'.$directory_name.'"; done');
	$path = "/storage/movies/".$directory_name;
	$dh = opendir($path);
	$i=1;
	while (($file = readdir($dh)) !== false) {
		if($file != "." && $file != "..") {
		$tracknum = str_pad($i, 2, "0", STR_PAD_LEFT);
		rename($path."//".$file, $path."//".$movie_title."_".$tracknum.".mkv");
		$i++;
		}
	}
	closedir($dh);	
	
// Single rip	
} else {
	echo "\nRipping main movie only (track ".$long_track_lsdvd.")\n\n";
	exec("/usr/bin/makemkvcon mkv --decrypt --progress=-stdout --minlength=120 dev:$cddevice ".($long_track - 1)." /storage/tmp/ripper.tmp >> /var/log/cdrip.log");
	$movie_title_path = "/storage/movies/".$movie_title.".mkv";
	
	// If movie name already exists create a new directory title
	if (file_exists($movie_title_path)) {
		$movie_title_path = "/storage/movies/".$movie_title."-".$start_time[0].".mkv";
		echo "Movie already exists, renaming movie to: $movie_title_path\n";
	} 

	exec('mv /storage/tmp/ripper.tmp/*.mkv "'.$movie_title_path.'"');
}

$end_time = getdate();
$difference = $end_time[0] - $start_time[0];
echo "\nRipping took ". intval($difference/60) ." minutes and ". ($difference - (intval($difference/60)*60))." seconds.\n";

if ($fp = fopen("/tmp/docd_helper_dvdname.tmp", 'w')) {
	fwrite($fp, $movie_title);
	fclose($fp); 
} else {
	echo 'Config file unwritable... '; 
}

if (file_exists("/etc/vortexbox/riptomp4")) {
	exec ('mkdir -p "/storage/movies/mp4/'.$directory_name.'"');
	echo "Converting .mkv tracks to .mp4, this can take a while...\n";

	if ($multirip == 1) {	
	  $path = "/storage/movies/".$directory_name;
	  $dh = opendir($path);
	  $i=1;
	  while (($file = readdir($dh)) !== false) {
	   if($file != "." && $file != "..") {
	      echo "Encoding /storage/movies/mp4/".$directory_name."/".substr($file,0,-4).".mp4\n";
		  exec('/usr/bin/ffmpeg -i "/storage/movies/'.$movie_title.'/'.$file.'" -loglevel 1 -vcodec mpeg2video -b 5500k -acodec copy -f vob -copyts -y "/storage/movies/mp4/'.$directory_name.'/'.substr($file,0,-4).'.mp4"');
		  $i++;
	   }
	  }
	  closedir($dh);
	} else {
	 	echo "Encoding /storage/movies/mp4/".$directory_name."/".$movie_title.".mp4\n";
		exec('/usr/bin/ffmpeg -i "/storage/movies/'.$movie_title.'.mkv" -loglevel 1 -vcodec mpeg2video -b 5500k -acodec copy -f vob -copyts -y "/storage/movies/mp4/'.$directory_name.'/'.$movie_title.'.mp4"');
	}
	
	// Create xml for Windows Media Center
	$myFile = "/storage/movies/mp4/".$directory_name."/".$movie_title.".dvdid.xml";
	$fh = fopen($myFile, 'w') or die("can't open file");
	$stringData = '<?xml version="1.0" encoding="utf-8"?>'."\n";
	fwrite($fh, $stringData);
	$stringData = "<Disc>\n";
	fwrite($fh, $stringData);
	$stringData = "     <Name>".$movie_title."</Name>\n";
	fwrite($fh, $stringData);
	$stringData = "     <ID>".strtoupper($dvdid)."</ID>\n";
	fwrite($fh, $stringData);
	$stringData = "</Disc>\n";
	fwrite($fh, $stringData);
	fclose($fh);

	echo "Finished converting to mp4.\n";
}

if (file_exists("/etc/vortexbox/riptom2ts")) {
	exec ('mkdir -p "/storage/movies/m2ts/'.$directory_name.'"');
	echo "Converting .mkv tracks to .m2ts, this can take a while...\n";

  	if ($multirip == 1) {	
  	  $path = "/storage/movies/".$directory_name;
 	  $m2path = "/storage/movies/m2ts/".$directory_name;
  	  $dh = opendir($path);
  	  while (($file = readdir($dh)) !== false) {
 	   if(!is_dir($file)) {
 	      echo "Encoding: ".$m2path."/".substr($file,0,-4).".m2ts\n";
		  exec('/usr/bin/ffmpeg -i "'.$path.'/'.$file.'" -loglevel 1 -vcodec copy -acodec copy -f mpegts -copyts -y "'.$m2path.'/'.substr($file,0,-4).'.m2ts"');
  	   }
  	  }
	  closedir($dh);
	} else {
	 	echo "Encoding /storage/movies/m2ts/".$directory_name."/".$movie_title.".m2ts\n";
		exec('/usr/bin/ffmpeg -i "/storage/movies/'.$movie_title.'.mkv" -loglevel 1 -vcodec copy -acodec copy -f mpegts -copyts -y "/storage/movies/m2ts/'.$directory_name.'/'.$movie_title.'.m2ts"');
	}
	
	echo "Finished converting to m2ts.\n";
}
?>
