#!/bin/sh
# Copyright (C) 2008 - 2011 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

function ipaddr {

IPADDR=`/sbin/ifconfig eth0 2>/dev/null|gawk '/inet addr/{print $2}'|gawk -F: '{print $2}'`
IPADDR2=`/sbin/ifconfig eth1 2>/dev/null|gawk '/inet addr/{print $2}'|gawk -F: '{print $2}'`
IPADDR3=`/sbin/ifconfig br0 2>/dev/null|gawk '/inet addr/{print $2}'|gawk -F: '{print $2}'`

if [ "$IPADDR" != "" ]; then
	echo "For web access to your VortexBox web GUI use http://$IPADDR";
elif [ "$IPADDR2" != "" ]; then
	echo "For web access to your VortexBox web GUI use http://$IPADDR2";
elif [ "$IPADDR3" != "" ]; then
	echo "For web access to your VortexBox web GUI use http://$IPADDR3";	
else	
	echo "No IP address for eth0: (DHCP not working?)";
fi
}

function startservices {

    # Only start minidlna if the user wants it autostarted on reboot
    if chkconfig --list | grep minidlna | grep on > /dev/null
		then
	    /sbin/service minidlna restart
    fi

    # Make sure VortexBox player startes
    if chkconfig --list | grep vortexbox-player | grep on > /dev/null
       then
	   /sbin/service vortexbox-player start
    fi
	
	# Make sure forked-daapd player startes
    if chkconfig --list | grep forked-daapd | grep on > /dev/null
       then
	   /sbin/service forked-daapd start
    fi

	# Start Wi-Fi gateway	
	if [ -f /etc/vortexbox/gateway.mode ]
		then
		/sbin/service dnsmasq start
		/opt/vortexbox/nat_router.sh
	fi
	
	# Start AP mode
	if [ -f /etc/vortexbox/ap.mode ]
		then
		/opt/vortexbox/ap_mode.sh
	fi
	
	/opt/vortexbox/myvb.php > /dev/null 2>&1

	# Start user defined process that requires the network
	if [ -f /usr/local/sbin/network_up.sh ]
		then
		/usr/local/sbin/network_up.sh &
	fi
}

# Start user defined custom network

if [ -f /usr/local/sbin/custom_network.sh ]
	then
	chmod +x /usr/local/sbin/custom_network.sh
	/usr/local/sbin/custom_network.sh &
fi	

# Check to see if network is up yet

if ! ping -c 1 -w 5 "google.com" &>/dev/null ; then
 for (( c=1; ; c++ ))
 do
   sleep 5
   IPBR0=`/sbin/ifconfig br0 2>/dev/null|gawk '/inet addr/{print $2}'|gawk -F: '{print $2}'`
   # Network is never comming up. Lets build our own netowrk.
   if [ c==5 ] && [ "$IPBR0"=="" ] && [ -f /etc/vortexbox/ap.mode ] ; then
     echo "Network timed out. Starting our own local network..."
	 /sbin/ifconfig br0 192.168.19.1 netmask 255.255.255.0
	 /usr/sbin/dnsmasq --dhcp-range=192.168.19.100,192.168.19.150,12h --dhcp-option=3,192.168.19.1 --no-hosts --no-resolv
	 startservices
     exit
   fi
   
   if ping -c 1 -w 5 "google.com" &>/dev/null ; then
    echo ""
	echo "Network is finally up."
	ipaddr
	echo ""
	
	echo "Adjusting time..."
	/sbin/service ntpd stop
	/usr/sbin/ntpdate pool.ntp.org
	/sbin/service ntpd start
	
	echo "Restarting some services that require the network..."
	startservices

    break
   fi
 done
else
	echo ""
	echo "Network is up."
	ipaddr
	echo ""
	echo "Adjusting time..."
	/sbin/service ntpd stop
	/usr/sbin/ntpdate pool.ntp.org
	/sbin/service ntpd start
	startservices
fi
