#!/bin/sh
# Copyright (C) 2008 - 2010 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

function echolog {
echo "`date +'%m/%d/%Y %H:%M:%S'` - $1"
}
/sbin/service transmission-daemon stop
echo "" >> /var/log/vbupgrade.log
echolog "Installing Transmission (This can take a long time...)" >> /var/log/vbupgrade.log


yum clean all
rm -rf /var/cache/yum/*
rm -rf /var/lib/yum/yumdb/*
yum -y install transmission transmission-daemon --skip-broken >> /var/log/vbupgrade.log

/sbin/service transmission-daemon start
sleep 3
/sbin/service transmission-daemon stop
sleep 3

cat > /var/lib/transmission/.config/transmission/settings.json <<EOF
{
    "alt-speed-down": 50,
    "alt-speed-enabled": false,
    "alt-speed-time-begin": 540,
    "alt-speed-time-day": 127,
    "alt-speed-time-enabled": false,
    "alt-speed-time-end": 1020,
    "alt-speed-up": 50,
    "bind-address-ipv4": "0.0.0.0",
    "bind-address-ipv6": "::",
    "blocklist-enabled": true,
    "dht-enabled": true,
    "download-dir": "\/storage\/downloads",
    "encryption": 1,
    "incomplete-dir": "\/var\/lib\/transmission\/.config\/transmission\/Incomplete",
    "incomplete-dir-enabled": false,
    "lazy-bitfield-enabled": true,
    "message-level": 2,
    "open-file-limit": 32,
    "peer-limit-global": 240,
    "peer-limit-per-torrent": 60,
    "peer-port": 51413,
    "peer-port-random-high": 65535,
    "peer-port-random-low": 49152,
    "peer-port-random-on-start": false,
    "peer-socket-tos": 0,
    "pex-enabled": true,
    "port-forwarding-enabled": true,
    "preallocation": 1,
    "proxy": "",
    "proxy-auth-enabled": false,
    "proxy-auth-password": "",
    "proxy-auth-username": "",
    "proxy-enabled": false,
    "proxy-port": 80,
    "proxy-type": 0,
    "ratio-limit": 2.0000,
    "ratio-limit-enabled": false,
    "rename-partial-files": true,
    "rpc-authentication-required": false,
    "rpc-bind-address": "0.0.0.0",
    "rpc-enabled": true,
    "rpc-password": "{e8b820b8d644f3624c423782e5799ee17bb3afbaij3kiX4s",
    "rpc-port": 9091,
    "rpc-username": "",
    "rpc-whitelist": "*",
    "rpc-whitelist-enabled": false,
    "speed-limit-down": 100,
    "speed-limit-down-enabled": false,
    "speed-limit-up": 100,
    "speed-limit-up-enabled": false,
    "umask": 18,
    "upload-slots-per-torrent": 14
}
EOF

mkdir -p  /storage/downloads/
chown -R transmission:transmission /storage/downloads
/sbin/chkconfig --level 345 transmission-daemon on
/sbin/service transmission-daemon start

touch /etc/vortexbox/packages/transmission
echolog "Transmission interface installed." >> /var/log/vbupgrade.log
