#!/bin/sh
# Copyright (C) 2008-2011 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

sleep 2

# homename workgroup
HOSTNAME=$1
HOSTUPPER=`echo $1 | tr "[:lower:]" "[:upper:]"`
WORKGROUP=$2

echo "NETWORKING=yes" > /etc/sysconfig/network
echo "HOSTNAME=$HOSTNAME.localdomain" >> /etc/sysconfig/network
echo "DHCP_HOSTNAME=$HOSTUPPER" >> /etc/sysconfig/network

echo "# Do not remove the following line, or various programs" > /etc/hosts
echo "# that require network functionality will fail." >> /etc/hosts
echo "127.0.0.1		$HOSTNAME.localdomain    $HOSTNAME   localhost.localdomain   localhost" >> /etc/hosts


cat > /etc/samba/smb.conf <<EOF
[global]
workgroup = $WORKGROUP
server string = VortexBox Media Server and SMB Master
local master = yes
domain master = yes
preferred master = yes
os level = 255
password server = None
guest ok = yes
guest account = root
security = SHARE
printcap name = /etc/printcap
netbios name = $HOSTUPPER

# These improve preformance
large readwrite = yes
socket options = TCP_NODELAY IPTOS_LOWDELAY SO_KEEPALIVE

# Fix for OSX
unix extensions = no

[files]
path = /storage
guest ok = yes
writeable = yes
create mask = 0777

[music]
path = /storage/music
guest ok = yes
writeable = no
create mask = 0777

[pictures]
path = /storage/pictures
guest ok = yes
writeable = no
create mask = 0777

[movies]
path = /storage/movies
guest ok = yes
writeable = no
create mask = 0777

EOF


if [ -f /etc/vortexbox/sonos.smb ]
then
cat >> /etc/samba/smb.conf <<EOF
[sonos-flac]
path = /storage/music/flac
guest ok = yes
writeable = no
create mask = 0777

[sonos-mp3]
path = /storage/music/mp3
guest ok = yes
writeable = no
create mask = 0777

EOF
fi

if [ -f /etc/vortexbox/keepout.smb ]
then
cat >> /etc/samba/smb.conf <<EOF
[keepout]
path = /
guest ok = yes
writeable = yes
create mask = 0777

EOF
fi

cp /var/tmp/ifcfg-eth0.new /etc/sysconfig/network-scripts/ifcfg-eth0
sleep 2
reboot