#!/bin/sh
# Copyright (C) 2008-2011 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# Changelog:
#
# Sat Jun 25 2011 Ron Olsen <ronolsen@comcast.net>
# * Don't fix permissions; this is already done on reboot in vb-startup.
# * Don't check for obsolete packages.
# * Only install minidlna and forked-daapd if they are not already installed.
# * Only start httpd if it is not already running.


# make sure minidlna is installed
service ushare stop
rpm -e vb-ushare
if [ ! -f /usr/sbin/minidlna ]
then
   #echo "installing minidlna"
   yum -y install minidlna
fi

# make sure forked-daapd is installed
service mt-daapd stop
rpm -e vb-mt-daapd
if [ ! -f /usr/sbin/forked-daapd ]
then
    #echo "installing forked-daapd"
    yum -y install forked-daapd
fi

# start httpd if it has been stopped during the upgrade
if echo $(service httpd status) | grep "is running" > /dev/null 
then
    #echo "httpd is running"
    continue
else
    #echo "httpd not running; restart httpd"
    service httpd start
fi

/sbin/chkconfig --add squeezeboxserver