#!/bin/bash
# Copyright (C) 2008 - 2011 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

sed -i '/DHCP_HOSTNAME/ d'  /etc/sysconfig/network-scripts/ifcfg-eth0
/etc/init.d/network reload > /dev/null 2>&1

if ! grep "^PS1" /etc/profile >/dev/null 2>&1; then
	echo 'PS1="[\H \W]# "' >> /etc/profile
fi

# auto reboot if there is a kernel panic
if ! grep "panic" /etc/sysctl.conf >/dev/null 2>&1; then
	echo "kernel.panic=5" >> /etc/sysctl.conf
fi

mkdir -p /storage/music/flac
mkdir -p /storage/music/mp3
mkdir -p /storage/music/playlist
mkdir -p /storage/pictures
mkdir -p /storage/movies

chown -R squeezeboxserver:squeezeboxserver /storage/music/playlist

echo "AmazonAffiliateId=vortexboxorg-20" > /root/musicutil.conf
echo "AmazonSubscriptionId=17Z9F60P7FBV64QEF9G2" >> /root/musicutil.conf

service squeezeboxserver stop
sleep 3

echo "_client:00:04:20:00:00:01:" > /etc/squeezeboxserver/server.conf
echo "  playername: VortexBox" >> /etc/squeezeboxserver/server.conf
echo "  maxBitrate: 0" >> /etc/squeezeboxserver/server.conf

echo "_client:00:04:20:00:00:02:" >> /etc/squeezeboxserver/server.conf
echo "  playername: VortexBox (Green)" >> /etc/squeezeboxserver/server.conf
echo "  maxBitrate: 0" >> /etc/squeezeboxserver/server.conf

echo "_client:00:04:20:00:00:03:" >> /etc/squeezeboxserver/server.conf
echo "  playername: VortexBox (Pink)" >> /etc/squeezeboxserver/server.conf
echo "  maxBitrate: 0" >> /etc/squeezeboxserver/server.conf

echo "_client:00:04:20:00:00:04:" >> /etc/squeezeboxserver/server.conf
echo "  playername: VortexBox (Gray)" >> /etc/squeezeboxserver/server.conf
echo "  maxBitrate: 0" >> /etc/squeezeboxserver/server.conf

echo "_client:00:04:20:00:00:10:" >> /etc/squeezeboxserver/server.conf
echo "  playername: VortexBox (USB1)" >> /etc/squeezeboxserver/server.conf
echo "  maxBitrate: 0" >> /etc/squeezeboxserver/server.conf

echo "_client:00:04:20:00:00:11:" >> /etc/squeezeboxserver/server.conf
echo "  playername: VortexBox (USB2)" >> /etc/squeezeboxserver/server.conf
echo "  maxBitrate: 0" >> /etc/squeezeboxserver/server.conf

echo "_client:00:04:20:00:00:12:" >> /etc/squeezeboxserver/server.conf
echo "  playername: VortexBox (USB3)" >> /etc/squeezeboxserver/server.conf
echo "  maxBitrate: 0" >> /etc/squeezeboxserver/server.conf

echo "_client:00:04:20:00:00:13:" >> /etc/squeezeboxserver/server.conf
echo "  playername: VortexBox (USB4)" >> /etc/squeezeboxserver/server.conf
echo "  maxBitrate: 0" >> /etc/squeezeboxserver/server.conf

echo "audiodir: /storage/music/flac" >> /etc/squeezeboxserver/server.conf
echo "mDNSname:" >> /etc/squeezeboxserver/server.conf
echo "playlistdir: /storage/music/playlist" >> /etc/squeezeboxserver/server.conf
echo "wizardDone: 1" >> /etc/squeezeboxserver/server.conf
