#!/bin/bash
# Copyright (C) 2008 - 2011 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

echo "-------------------------------------------"
echo "Configure Services"
echo "-------------------------------------------"

# Setup ntp time service
service ntpd stop
sleep 2
echo "driftfile /var/lib/ntp/drift" > /etc/ntp.conf
echo "server 0.pool.ntp.org" >> /etc/ntp.conf
echo "server 1.pool.ntp.org" >> /etc/ntp.conf
echo "server 2.pool.ntp.org" >> /etc/ntp.conf
echo "server 127.127.1.0" >> /etc/ntp.conf
echo "fudge 127.127.1.0 stratum 10" >> /etc/ntp.conf
ntpdate pool.ntp.org

# Remove unused services
chkconfig --del cups
chkconfig --del gpm
chkconfig --del cpuspeed
chkconfig --del bluez
chkconfig ip6tables off
chkconfig iptables off
chkconfig pcscd off

# Add required services
cp /var/vortexbox_load/smb.conf /etc/samba/smb.conf

cp /var/vortexbox_load/AppleVolumes.default /etc/atalk

cp /var/vortexbox_load/afpd.service /etc/avahi/services/
cp /var/vortexbox_load/http.service /etc/avahi/services/
cp /var/vortexbox_load/slimhttp.service /etc/avahi/services/

cp /var/vortexbox_load/rsyncd.conf /etc/rsyncd.conf

echo "/storage *(ro)" > /etc/exports
chkconfig --level 345 nfs on
exportfs -a

chkconfig --add vortexbox
chkconfig --level 345 ntpd on
chkconfig --level 345 mysqld on
chkconfig --level 345 httpd on
chkconfig --level 345 smb on
chkconfig --level 345 nmb on
chkconfig --level 345 atalk on
chkconfig rsync on
 